Index: squid/src/comm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm.c,v
retrieving revision 1.4.6.11
retrieving revision 1.4.6.12
diff -u -r1.4.6.11 -r1.4.6.12
--- squid/src/comm.c	1 Jul 2007 08:34:27 -0000	1.4.6.11
+++ squid/src/comm.c	2 Jul 2007 07:36:57 -0000	1.4.6.12
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm.c,v 1.4.6.11 2007/07/01 08:34:27 amosjeffries Exp $
+ * $Id: comm.c,v 1.4.6.12 2007/07/02 07:36:57 amosjeffries Exp $
  *
  * DEBUG: section 5     Socket Functions
  * AUTHOR: Harvest Derived
@@ -50,19 +50,18 @@
 typedef struct {
     char *host;
     u_short port;
-    struct sockaddr_storage S;
+    struct sockaddr_in S;
     CNCB *callback;
     void *data;
-    struct sockaddr_storage in_addr;
+    struct in_addr in_addr;
     int fd;
     int tries;
-    int ia_cur;
     int addrcount;
     int connstart;
 } ConnectStateData;
 
 /* STATIC */
-static int commBind(int s, struct sockaddr *S);
+static int commBind(int s, struct in_addr, u_short port);
 static void commSetReuseAddr(int);
 static void commSetNoLinger(int);
 static void CommWriteStateCallbackAndFree(int fd, int code);
@@ -112,7 +111,7 @@
 u_short
 comm_local_port(int fd)
 {
-    struct sockaddr_storage addr;
+    struct sockaddr_in addr;
     socklen_t addr_len = 0;
     fde *F = &fd_table[fd];
 
@@ -123,29 +122,33 @@
     }
     if (F->local_port)
 	return F->local_port;
-    addr_len = sizeof(struct sockaddr_storage);
+    addr_len = sizeof(addr);
     if (getsockname(fd, (struct sockaddr *) &addr, &addr_len)) {
 	debug(5, 1) ("comm_local_port: Failed to retrieve TCP/UDP port number for socket: FD %d: %s\n", fd, xstrerror());
 	return 0;
     }
-    F->local_port = (addr.ss_family == AF_INET6) ?
-		ntohs(((struct sockaddr_in6 *)&addr)->sin6_port):
-		ntohs(((struct sockaddr_in *)&addr)->sin_port) ;
+    F->local_port = ntohs(addr.sin_port);
     debug(5, 6) ("comm_local_port: FD %d: port %d\n", fd, (int) F->local_port);
     return F->local_port;
 }
 
 static int
-commBind(int s, struct sockaddr *S)
+commBind(int s, struct in_addr in_addr, u_short port)
 {
-    char hbuf[80], sbuf[8];
+    struct sockaddr_in S;
+
+    memset(&S, '\0', sizeof(S));
+    S.sin_family = AF_INET;
+    S.sin_port = htons(port);
+    S.sin_addr = in_addr;
     statCounter.syscalls.sock.binds++;
-    if (bind(s, S, SOCKLEN(S)) == 0)
+    if (bind(s, (struct sockaddr *) &S, sizeof(S)) == 0)
 	return COMM_OK;
-    getnameinfo(S, S->sa_family, hbuf, 80, sbuf, 8,
-	NI_NUMERICHOST|NI_NUMERICSERV);
-    debug(5, 0) ("commBind: Cannot bind socket FD %d to %s:%s: %s\n",
-	s, hbuf, sbuf, xstrerror());
+    debug(5, 0) ("commBind: Cannot bind socket FD %d to %s:%d: %s\n",
+	s,
+	S.sin_addr.s_addr == INADDR_ANY ? "*" : inet_ntoa(S.sin_addr),
+	(int) port,
+	xstrerror());
     return COMM_ERROR;
 }
 
@@ -154,11 +157,12 @@
 int
 comm_open(int sock_type,
     int proto,
-    struct sockaddr *addr,
+    struct in_addr addr,
+    u_short port,
     int flags,
     const char *note)
 {
-    return comm_openex(sock_type, proto, addr, flags, 0, note);
+    return comm_openex(sock_type, proto, addr, port, flags, 0, note);
 }
 
 
@@ -167,19 +171,19 @@
 int
 comm_openex(int sock_type,
     int proto,
-    struct sockaddr *addr,
+    struct in_addr addr,
+    u_short port,
     int flags,
     unsigned char TOS,
     const char *note)
 {
     int new_socket;
-    u_short port;
     int tos = 0;
     fde *F = NULL;
 
     /* Create socket for accepting new connections. */
     statCounter.syscalls.sock.sockets++;
-    if ((new_socket = socket(addr->sa_family, sock_type, proto)) < 0) {
+    if ((new_socket = socket(AF_INET, sock_type, proto)) < 0) {
 	/* Increase the number of reserved fd's if calls to socket()
 	 * are failing because the open file table is full.  This
 	 * limits the number of simultaneous clients */
@@ -209,15 +213,12 @@
     debug(5, 5) ("comm_open: FD %d is a new socket\n", new_socket);
     fd_open(new_socket, FD_SOCKET, note);
     F = &fd_table[new_socket];
-    xmemcpy(&F->local_addr, addr, SOCKLEN(addr));
+    F->local_addr = addr;
     F->tos = tos;
     if (!(flags & COMM_NOCLOEXEC))
 	commSetCloseOnExec(new_socket);
     if ((flags & COMM_REUSEADDR))
 	commSetReuseAddr(new_socket);
-    port = (addr->sa_family == AF_INET6) ?
-	    ntohs(((struct sockaddr_in6 *)addr)->sin6_port) :
-	    ntohs(((struct sockaddr_in *)addr)->sin_port);
     if (port > (u_short) 0) {
 #ifdef _SQUID_MSWIN_
 	if (sock_type != SOCK_DGRAM)
@@ -226,38 +227,14 @@
 	if (opt_reuseaddr)
 	    commSetReuseAddr(new_socket);
     }
-    switch (addr->sa_family) {
-    case AF_INET:
-        if (((struct sockaddr_in *)addr)->sin_addr.s_addr != no_addr.s_addr) {
-            if (commBind(new_socket, addr) != COMM_OK) {
-                comm_close(new_socket);
-                return -1;
-            }
-        }
-        F->local_port = ntohs(((struct sockaddr_in *)addr)->sin_port);
-    break;
-    case AF_INET6:
-    {
-        struct in6_addr *s6 = &((struct sockaddr_in6 *)addr)->sin6_addr; 
-        if (!IN6_IS_ADDR_ALLF( s6 ) ) {
-#ifdef IPV6_V6ONLY
-            const int on = 1;
-            if (setsockopt(new_socket, IPPROTO_IPV6, IPV6_V6ONLY, &on, sizeof(on)) < 0) {
-                comm_close(new_socket);
-                return -1;
-            }
-#endif
-            if (commBind(new_socket, addr) != COMM_OK) {
-                comm_close(new_socket);
-                return -1;
-            }
-        }
-        F->local_port = ntohs(((struct sockaddr_in6 *)addr)->sin6_port);
-    }
-    break;
+    if (addr.s_addr != no_addr.s_addr) {
+	if (commBind(new_socket, addr, port) != COMM_OK) {
+	    comm_close(new_socket);
+	    return -1;
+	}
     }
+    F->local_port = port;
 
-    xmemcpy(&F->local_addr, addr, SOCKLEN(addr));
     if (flags & COMM_NONBLOCKING)
 	if (commSetNonBlocking(new_socket) == COMM_ERROR)
 	    return -1;
@@ -291,10 +268,9 @@
 }
 
 void
-commConnectStart(int fd, const char *host, u_short port, CNCB * callback, void *data, struct sockaddr *addr)
+commConnectStart(int fd, const char *host, u_short port, CNCB * callback, void *data, struct in_addr *addr)
 {
     ConnectStateData *cs;
-    FwdState *fwdState = data;
     debug(5, 3) ("commConnectStart: FD %d, %s:%d\n", fd, host, (int) port);
     cs = cbdataAlloc(ConnectStateData);
     cs->fd = fd;
@@ -303,12 +279,11 @@
     cs->callback = callback;
     cs->data = data;
     if (addr != NULL) {
-	xmemcpy(&cs->in_addr, addr, sizeof(struct sockaddr_storage));
+	cs->in_addr = *addr;
 	cs->addrcount = 1;
     } else {
 	cs->addrcount = 0;
     }
-    cs->ia_cur= fwdState->ia_cur;
     cbdataLock(cs->data);
     comm_add_close_handler(fd, commConnectFree, cs);
     ipcache_nbgethostbyname(host, commConnectDnsHandle, cs);
@@ -336,15 +311,9 @@
 	return;
     }
     assert(ia->cur < ia->count);
-    if (Config.onoff.balance_on_multiple_ip) {
-	if (cs->ia_cur < 0) {
-	    ipcacheCycleAddr(cs->host, NULL);
-	    cs->ia_cur = ia->cur;
-	}
-    }
-    else
-	cs->ia_cur = ia->cur;
-    xmemcpy(&cs->in_addr, &ia->in_addrs[cs->ia_cur], sizeof(struct sockaddr_storage));
+    cs->in_addr = ia->in_addrs[ia->cur];
+    if (Config.onoff.balance_on_multiple_ip)
+	ipcacheCycleAddr(cs->host, NULL);
     cs->addrcount = ia->count;
     cs->connstart = squid_curtime;
     commConnectHandle(cs->fd, cs);
@@ -355,9 +324,7 @@
 {
     CNCB *callback = cs->callback;
     void *data = cs->data;
-    FwdState *fwdState = cs->data;
     int fd = cs->fd;
-    fwdState->ia_cur = cs->ia_cur;
     comm_remove_close_handler(fd, commConnectFree, cs);
     cs->callback = NULL;
     cs->data = NULL;
@@ -385,17 +352,10 @@
 {
     int fd2;
     fde *F;
-    struct sockaddr_storage oldsock;
-    socklen_t oldsocklen = sizeof(oldsock);
     if (!cbdataValid(cs->data))
 	return 0;
     statCounter.syscalls.sock.sockets++;
-    getsockname(cs->fd, (struct sockaddr *)&oldsock, &oldsocklen);
-    F = &fd_table[cs->fd];
-    if (F->local_addr.ss_family == AF_INET6)
-	fd2 = socket(AF_INET6, SOCK_STREAM, 0);
-    else
-	fd2 = socket(AF_INET, SOCK_STREAM, 0);
+    fd2 = socket(AF_INET, SOCK_STREAM, 0);
     statCounter.syscalls.sock.sockets++;
     if (fd2 < 0) {
 	debug(5, 0) ("commResetFD: socket: %s\n", xstrerror());
@@ -418,12 +378,13 @@
 	return 0;
     }
     close(fd2);
+    F = &fd_table[cs->fd];
     fd_table[cs->fd].flags.called_connect = 0;
     /*
      * yuck, this has assumptions about comm_open() arguments for
      * the original socket
      */
-    if (commBind(cs->fd, &F->local_addr) != COMM_OK) {
+    if (commBind(cs->fd, F->local_addr, F->local_port) != COMM_OK) {
 	debug(5, 0) ("commResetFD: bind: %s\n", xstrerror());
 	return 0;
     }
@@ -478,14 +439,10 @@
 commConnectHandle(int fd, void *data)
 {
     ConnectStateData *cs = data;
-    struct sockaddr *sa;
-    if ((cs->in_addr.ss_family == AF_INET) || (cs->in_addr.ss_family == AF_INET6)) {
-	xmemcpy(&cs->S, &cs->in_addr, sizeof(struct sockaddr_storage));
-        sa =(struct sockaddr *)&cs->S;
-        if (sa->sa_family == AF_INET6) 
-	    ((struct sockaddr_in6 *)&cs->S)->sin6_port = htons(cs->port);
-	else
-	    ((struct sockaddr_in *)&cs->S)->sin_port = htons(cs->port);
+    if (cs->S.sin_addr.s_addr == 0) {
+	cs->S.sin_family = AF_INET;
+	cs->S.sin_addr = cs->in_addr;
+	cs->S.sin_port = htons(cs->port);
     }
     switch (comm_connect_addr(fd, &cs->S)) {
     case COMM_INPROGRESS:
@@ -493,18 +450,14 @@
 	commSetSelect(fd, COMM_SELECT_WRITE, commConnectHandle, cs, 0);
 	break;
     case COMM_OK:
-	ipcacheMarkGoodAddr(cs->host, &cs->S);
+	ipcacheMarkGoodAddr(cs->host, cs->S.sin_addr);
 	commConnectCallback(cs, COMM_OK);
 	break;
-    case COMM_ERR_NOSUPPORT:
-    case COMM_ERR_INV_ARGS:
-	commConnectCallback(cs, COMM_ERR_INV_ARGS);
-	break;
     default:
 	cs->tries++;
-	ipcacheMarkBadAddr(cs->host, &cs->S);
+	ipcacheMarkBadAddr(cs->host, cs->S.sin_addr);
 	if (Config.onoff.test_reachability)
-	    netdbDeleteAddrNetwork(&cs->S);
+	    netdbDeleteAddrNetwork(cs->S.sin_addr);
 	if (commRetryConnect(cs)) {
 	    eventAdd("commReconnect", commReconnect, cs, cs->addrcount == 1 ? 0.05 : 0.0, 0);
 	} else {
@@ -537,31 +490,26 @@
 }
 
 int
-comm_connect_addr(int sock, const struct sockaddr *address)
+comm_connect_addr(int sock, const struct sockaddr_in *address)
 {
     int status = COMM_OK;
     fde *F = &fd_table[sock];
     int x;
     int err = 0;
     socklen_t errlen;
-
-    if (address->sa_family == AF_INET6) 
-	assert(ntohs(((struct sockaddr_in6 *)address)->sin6_port) != 0);
-    else
-	assert(ntohs(((struct sockaddr_in *)address)->sin_port) != 0);
+    assert(ntohs(address->sin_port) != 0);
     /* Establish connection. */
     errno = 0;
     if (!F->flags.called_connect) {
 	F->flags.called_connect = 1;
 	statCounter.syscalls.sock.connects++;
-	x = connect(sock, address, SOCKLEN(address));
+	x = connect(sock, (struct sockaddr *) address, sizeof(*address));
 	if (x < 0)
-	    debug(5, 2) ("connect FD %d to %s : %s\n", sock, 
-		sockaddr_ntoa((struct sockaddr *)address), xstrerror());
+	    debug(5, 9) ("connect FD %d: %s\n", sock, xstrerror());
     } else {
 #if defined(_SQUID_NEWSOS6_)
 	/* Makoto MATSUSHITA <matusita@ics.es.osaka-u.ac.jp> */
-	connect(sock, address, SOCKLEN(address));
+	connect(sock, (struct sockaddr *) address, sizeof(*address));
 	if (errno == EINVAL) {
 	    errlen = sizeof(err);
 	    x = getsockopt(sock, SOL_SOCKET, SO_ERROR, &err, &errlen);
@@ -589,16 +537,10 @@
 	status = COMM_OK;
     else if (ignoreErrno(errno))
 	status = COMM_INPROGRESS;
-    else if (errno == COMM_ERR_INV_ARGS)
-        return COMM_ERR_INV_ARGS;
-    else if (errno == COMM_ERR_NOSUPPORT)
-        return COMM_ERR_INV_ARGS;
     else
 	return COMM_ERROR;
-    xstrncpy(F->ipaddr, sockaddr_ntoa((struct sockaddr *)address), 80);
-    F->remote_port = (address->sa_family == AF_INET6) ?
-              ntohs(((struct sockaddr_in6 *)address)->sin6_port) :
-              ntohs(((struct sockaddr_in *)address)->sin_port);
+    xstrncpy(F->ipaddr, xinet_ntoa(address->sin_addr), 16);
+    F->remote_port = ntohs(address->sin_port);
     if (status == COMM_OK) {
 	debug(5, 10) ("comm_connect_addr: FD %d connected to %s:%d\n",
 	    sock, F->ipaddr, F->remote_port);
@@ -611,11 +553,11 @@
 /* Wait for an incoming connection on FD.  FD should be a socket returned
  * from comm_listen. */
 int
-comm_accept(int fd, struct sockaddr *pn, struct sockaddr *me)
+comm_accept(int fd, struct sockaddr_in *pn, struct sockaddr_in *me)
 {
     int sock;
-    struct sockaddr_storage P;
-    struct sockaddr_storage M;
+    struct sockaddr_in P;
+    struct sockaddr_in M;
     socklen_t Slen;
     fde *F = NULL;
     Slen = sizeof(P);
@@ -633,27 +575,19 @@
 	}
     }
     if (pn)
-        xmemcpy(pn, &P, SOCKLEN(&P));
+	*pn = P;
     Slen = sizeof(M);
     memset(&M, '\0', Slen);
     getsockname(sock, (struct sockaddr *) &M, &Slen);
     if (me)
-        xmemcpy(me, &M, SOCKLEN(&M));
+	*me = M;
     commSetCloseOnExec(sock);
     /* fdstat update */
     fd_open(sock, FD_SOCKET, "HTTP Request");
     F = &fd_table[sock];
-    xstrncpy(F->ipaddr, sockaddr_ntoa((struct sockaddr *)&P), 80);
-    switch (P.ss_family) {
-    case AF_INET6:
-        F->remote_port = ntohs(((struct sockaddr_in6 *)&P)->sin6_port);
-        F->local_port = ntohs(((struct sockaddr_in6 *)&M)->sin6_port);
-        break;
-    case AF_INET:
-        F->remote_port = ntohs(((struct sockaddr_in *)&P)->sin_port);
-        F->local_port = ntohs(((struct sockaddr_in *)&M)->sin_port);
-        break;
-    }
+    xstrncpy(F->ipaddr, xinet_ntoa(P.sin_addr), 16);
+    F->remote_port = htons(P.sin_port);
+    F->local_port = htons(M.sin_port);
     commSetNonBlocking(sock);
     return sock;
 }
@@ -841,25 +775,22 @@
 /* Send a udp datagram to specified TO_ADDR. */
 int
 comm_udp_sendto(int fd,
-    const struct sockaddr *to_addr,
+    const struct sockaddr_in *to_addr,
     int addr_len,
     const void *buf,
     int len)
 {
     int x;
-    char hbuf[100], sbuf[8];
     statCounter.syscalls.sock.sendtos++;
-    x = sendto(fd, buf, len, 0, to_addr, SOCKLEN(to_addr));
+    x = sendto(fd, buf, len, 0, (struct sockaddr *) to_addr, addr_len);
     if (x < 0) {
-	getnameinfo(to_addr, SOCKLEN(to_addr), hbuf, 100, sbuf, 8,
-		NI_NUMERICHOST|NI_NUMERICSERV);
 #ifdef _SQUID_LINUX_
 	if (ECONNREFUSED != errno)
 #endif
-	    debug(5, 1) ("comm_udp_sendto: FD %d, %s, port %s: %s\n",
+	    debug(5, 1) ("comm_udp_sendto: FD %d, %s, port %d: %s\n",
 		fd,
-		hbuf,
-		sbuf,
+		inet_ntoa(to_addr->sin_addr),
+		(int) htons(to_addr->sin_port),
 		xstrerror());
 	return COMM_ERROR;
     }
Index: squid/src/comm_generic.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/comm_generic.c,v
retrieving revision 1.8.14.3
retrieving revision 1.8.14.4
diff -u -r1.8.14.3 -r1.8.14.4
--- squid/src/comm_generic.c	1 Jul 2007 05:44:21 -0000	1.8.14.3
+++ squid/src/comm_generic.c	2 Jul 2007 07:36:57 -0000	1.8.14.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: comm_generic.c,v 1.8.14.3 2007/07/01 05:44:21 amosjeffries Exp $
+ * $Id: comm_generic.c,v 1.8.14.4 2007/07/02 07:36:57 amosjeffries Exp $
  *
  * DEBUG: section 5     Socket Functions
  *
@@ -165,10 +165,6 @@
 	do_call_incoming(theInIcpConnection);
     if (theOutIcpConnection != theInIcpConnection)
 	do_call_incoming(theOutIcpConnection);
-    if (theInIcpConnection6 >= 0)
-	do_call_incoming(theInIcpConnection6);
-    if (theOutIcpConnection6 != theInIcpConnection6)
-	do_call_incoming(theOutIcpConnection6);
 }
 
 static inline void
Index: squid/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/defines.h,v
retrieving revision 1.3.6.10
retrieving revision 1.3.6.11
diff -u -r1.3.6.10 -r1.3.6.11
--- squid/src/defines.h	1 Jul 2007 05:44:22 -0000	1.3.6.10
+++ squid/src/defines.h	2 Jul 2007 07:36:58 -0000	1.3.6.11
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.3.6.10 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: defines.h,v 1.3.6.11 2007/07/02 07:36:58 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -84,8 +84,6 @@
 #define COMM_ERR_CONNECT (-7)
 #define COMM_ERR_DNS     (-8)
 #define COMM_ERR_CLOSING (-9)
-#define COMM_ERR_INV_ARGS (22)
-#define COMM_ERR_NOSUPPORT (97)
 
 /* Select types. */
 #define COMM_SELECT_READ   (0x1)
@@ -366,18 +364,4 @@
 #define	DLINK_ISEMPTY(n)	( (n).head == NULL )
 #define	DLINK_HEAD(n)		( (n).head->data )
 
-/*
- * Macro to compare IPv6 addresses (b is 0, 4, 8, 12)
- */
-#define IN6_NTOHL_N(a,b)        \
-        (ntohl(*(const u_int32_t *)(const void *)(&(a)->s6_addr[(b)])))
-
-#define IN6_IS_ADDR_ALLF(a)	\
-	(IN6_NTOHL_N(a,0) & IN6_NTOHL_N(a,4) & 			\
-		IN6_NTOHL_N(a,8) & IN6_NTOHL_N(a,12) == 	\
-		(u_int32_t)0xffffffff)
-
-#define SOCKLEN(a)	\
-	(((struct sockaddr_storage *)(a))->ss_family == AF_INET6 ?	\
-	    sizeof(struct sockaddr_in6) : sizeof(struct sockaddr_in))
 #endif /* SQUID_DEFINES_H */
Index: squid/src/delay_pools.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/delay_pools.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/delay_pools.c	1 Jul 2007 05:44:22 -0000	1.3.6.5
+++ squid/src/delay_pools.c	2 Jul 2007 07:36:58 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: delay_pools.c,v 1.3.6.5 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: delay_pools.c,v 1.3.6.6 2007/07/02 07:36:58 amosjeffries Exp $
  *
  * DEBUG: section 77    Delay Pools
  * AUTHOR: David Luyer <david@luyer.net>
@@ -319,8 +319,7 @@
     memset(&ch, '\0', sizeof(ch));
     ch.conn = http->conn;
     ch.request = r;
-    if(r->client_addr.ss_family == AF_INET &&
-      ((struct sockaddr_in *)&r->client_addr)->sin_addr.s_addr == INADDR_BROADCAST) {
+    if (r->client_addr.s_addr == INADDR_BROADCAST) {
 	debug(77, 2) ("delayClient: WARNING: Called with 'allones' address, ignoring\n");
 	return delayId(0, 0);
     }
@@ -336,10 +335,7 @@
     if (class == 1)
 	return delayId(pool + 1, 0);
     if (class == 2) {
-/* XXX husni
 	host = ntohl(ch.src_addr.s_addr) & 0xff;
-*/
-	host = 255;
 	if (host == 255) {
 	    if (!delay_data[pool].class2->individual_255_used) {
 		delay_data[pool].class2->individual_255_used = 1;
@@ -365,10 +361,7 @@
 	return delayId(pool + 1, i);
     }
     /* class == 3 */
-/* XXX husni
     host = ntohl(ch.src_addr.s_addr) & 0xffff;
-*/
-    host = 0xffff;
     net = host >> 8;
     host &= 0xff;
     if (net == 255) {
Index: squid/src/dns_internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns_internal.c,v
retrieving revision 1.5.6.9
retrieving revision 1.5.6.10
diff -u -r1.5.6.9 -r1.5.6.10
--- squid/src/dns_internal.c	1 Jul 2007 05:44:22 -0000	1.5.6.9
+++ squid/src/dns_internal.c	2 Jul 2007 07:36:59 -0000	1.5.6.10
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns_internal.c,v 1.5.6.9 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: dns_internal.c,v 1.5.6.10 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 78    DNS lookups; interacts with lib/rfc1035.c
  * AUTHOR: Duane Wessels
@@ -89,13 +89,12 @@
 
 struct _idns_query {
     hash_link hash;
-    int ia_cur;
     rfc1035_query query;
     char buf[RESOLV_BUFSZ];
     char name[NS_MAXDNAME + 1];
     char orig[NS_MAXDNAME + 1];
     ssize_t sz;
-    unsigned short id, id_pair;
+    unsigned short id;
     int nsends;
     struct timeval start_t;
     struct timeval sent_t;
@@ -115,7 +114,7 @@
 };
 
 struct _ns {
-    struct sockaddr_storage S;
+    struct sockaddr_in S;
     int nqueries;
     int nreplies;
 };
@@ -151,7 +150,7 @@
 #endif
 static void idnsCacheQuery(idns_query * q);
 static void idnsSendQuery(idns_query * q);
-static int idnsFromKnownNameserver(struct sockaddr *from);
+static int idnsFromKnownNameserver(struct sockaddr_in *from);
 static idns_query *idnsFindQuery(unsigned short id);
 static void idnsGrokReply(const char *buf, size_t sz);
 static PF idnsRead;
@@ -162,13 +161,12 @@
 static void
 idnsAddNameserver(const char *buf)
 {
-    struct sockaddr_storage A;
+    struct in_addr A;
     if (!safe_inet_addr(buf, &A)) {
 	debug(78, 0) ("WARNING: rejecting '%s' as a name server, because it is not a numeric IP address\n", buf);
 	return;
     }
-    if ( ((A.ss_family == AF_INET6) && IN6_IS_ADDR_UNSPECIFIED(&((struct sockaddr_in6 *)&A)->sin6_addr)) ||
-    	((A.ss_family == AF_INET) && (((struct sockaddr_in *)&A)->sin_addr.s_addr == 0)) ) {
+    if (A.s_addr == 0) {
 	debug(78, 0) ("WARNING: Squid does not accept 0.0.0.0 in DNS server specifications.\n");
 	debug(78, 0) ("Will be using 127.0.0.1 instead, assuming you meant that DNS is running on the same machine\n");
 	safe_inet_addr("127.0.0.1", &A);
@@ -187,13 +185,11 @@
 	    safe_free(oldptr);
     }
     assert(nns < nns_alloc);
-    xmemcpy(&nameservers[nns].S, &A, sizeof(struct sockaddr_storage));
-    if (A.ss_family == AF_INET)
-	((struct sockaddr_in *)&nameservers[nns].S)->sin_port =  htons(NS_DEFAULTPORT);
-    if (A.ss_family == AF_INET6)
-	((struct sockaddr_in6 *)&nameservers[nns].S)->sin6_port =  htons(NS_DEFAULTPORT);
+    nameservers[nns].S.sin_family = AF_INET;
+    nameservers[nns].S.sin_port = htons(NS_DEFAULTPORT);
+    nameservers[nns].S.sin_addr.s_addr = A.s_addr;
     debug(78, 3) ("idnsAddNameserver: Added nameserver #%d: %s\n",
-	nns, sockaddr_ntoa(&nameservers[nns].S));
+	nns, inet_ntoa(nameservers[nns].S.sin_addr));
     nns++;
 }
 
@@ -503,7 +499,7 @@
     storeAppendPrintf(sentry, "--------------- --------- ---------\n");
     for (i = 0; i < nns; i++) {
 	storeAppendPrintf(sentry, "%-15s %9d %9d\n",
-	    sockaddr_ntoa(&nameservers[i].S),
+	    inet_ntoa(nameservers[i].S.sin_addr),
 	    nameservers[i].nqueries,
 	    nameservers[i].nreplies);
     }
@@ -555,7 +551,6 @@
 {
     int x;
     int ns;
-    int DnsSocketTemp;
     if (DnsSocket < 0) {
 	debug(78, 1) ("idnsSendQuery: Can't send query, no DNS socket!\n");
 	return;
@@ -567,29 +562,21 @@
     idnsTcpCleanup(q);
   try_again:
     ns = q->nsends % nns;
-    if (nameservers[ns].S.ss_family == AF_INET6)
-	DnsSocketTemp = DnsSocket6;
-    else
-	DnsSocketTemp = DnsSocket;
-	
-    x = comm_udp_sendto(DnsSocketTemp,
+    x = comm_udp_sendto(DnsSocket,
 	&nameservers[ns].S,
-	SOCKLEN(&nameservers[ns].S),
+	sizeof(nameservers[ns].S),
 	q->buf,
 	q->sz);
     q->nsends++;
     q->sent_t = current_time;
     if (x < 0) {
 	debug(50, 1) ("idnsSendQuery: FD %d: sendto: %s\n",
-	    DnsSocketTemp, xstrerror());
+	    DnsSocket, xstrerror());
 	if (q->nsends % nns != 0)
 	    goto try_again;
     } else {
-	fd_bytes(DnsSocketTemp, x, FD_WRITE);
-/*
-	if (q->query.qtype == RFC1035_TYPE_A)
-*/
-	commSetSelect(DnsSocketTemp, COMM_SELECT_READ, idnsRead, NULL, 0);
+	fd_bytes(DnsSocket, x, FD_WRITE);
+	commSetSelect(DnsSocket, COMM_SELECT_READ, idnsRead, NULL, 0);
     }
     nameservers[ns].nqueries++;
     dlinkAdd(q, &q->lru, &lru_list);
@@ -597,19 +584,13 @@
 }
 
 static int
-idnsFromKnownNameserver(struct sockaddr *from)
+idnsFromKnownNameserver(struct sockaddr_in *from)
 {
     int i;
     for (i = 0; i < nns; i++) {
-	if (nameservers[i].S.ss_family != from->sa_family)
-	    continue;
-	if (from->sa_family == AF_INET &&
-	    (((struct sockaddr_in *)&nameservers[i].S)->sin_addr.s_addr != ((struct sockaddr_in *)from)->sin_addr.s_addr ||
-	    ((struct sockaddr_in *)&nameservers[i].S)->sin_port != ((struct sockaddr_in *)from)->sin_port))
+	if (nameservers[i].S.sin_addr.s_addr != from->sin_addr.s_addr)
 	    continue;
-	if (from->sa_family == AF_INET6 &&
-	    (!IN6_ARE_ADDR_EQUAL( &((struct sockaddr_in6 *)&nameservers[i].S)->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr) ||
-	    ((struct sockaddr_in6 *)&nameservers[i].S)->sin6_port != ((struct sockaddr_in6 *)from)->sin6_port))
+	if (nameservers[i].S.sin_port != from->sin_port)
 	    continue;
 	return i;
     }
@@ -743,29 +724,23 @@
 static void
 idnsRetryTcp(idns_query * q)
 {
-    struct sockaddr_storage addr;
-    char host[100], port[8];
+    struct in_addr addr;
     int ns = (q->nsends - 1) % nns;
     idnsTcpCleanup(q);
-    if ((Config.Addrs.udp_outgoing.ss_family == AF_INET6 &&
-!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&Config.Addrs.udp_outgoing)->sin6_addr)) 
-	|| (Config.Addrs.udp_outgoing.ss_family == AF_INET &&
-	((struct sockaddr_in *)&Config.Addrs.udp_outgoing)->sin_addr.s_addr != no_addr.s_addr))
-	xmemcpy(&addr, &Config.Addrs.udp_outgoing, sizeof(addr));
+    if (Config.Addrs.udp_outgoing.s_addr != no_addr.s_addr)
+	addr = Config.Addrs.udp_outgoing;
     else
-	xmemcpy(&addr, &Config.Addrs.udp_incoming, sizeof(addr));
+	addr = Config.Addrs.udp_incoming;
     q->tcp_socket = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	&addr,
+	addr,
+	0,
 	COMM_NONBLOCKING,
 	"DNS TCP Socket");
     dlinkAdd(q, &q->lru, &lru_list);
-    q->ia_cur = -1;
     commConnectStart(q->tcp_socket,
-	sockaddr_ntoa(&addr),
-	addr.ss_family == AF_INET6 ?
-	    ntohs(((struct sockaddr_in6 *)&addr)->sin6_port) :
-	    ntohs(((struct sockaddr_in *)&addr)->sin_port) ,
+	inet_ntoa(nameservers[ns].S.sin_addr),
+	ntohs(nameservers[ns].S.sin_port),
 	idnsSendTcpQuery,
 	q,
 	NULL
@@ -777,7 +752,7 @@
 {
     int n;
     rfc1035_message *message = NULL;
-    idns_query *q, *q_pair;
+    idns_query *q;
     n = rfc1035MessageUnpack(buf,
 	sz,
 	&message);
@@ -794,9 +769,6 @@
 	rfc1035MessageDestroy(message);
 	return;
     }
-
-    q_pair = idnsFindQuery(q->id_pair);
-
     if (rfc1035QueryCompare(&q->query, message->query) != 0) {
 	debug(78, 3) ("idnsGrokReply: Query mismatch (%s != %s)\n", q->query.name, message->query->name);
 	rfc1035MessageDestroy(message);
@@ -856,19 +828,11 @@
 	    return;
 	}
     }
-    if (q_pair)
-	n = n + 10000;
-    debug(78, 3) ("idnsGrokReply: id %d pair %d: %d\n", q->id, q_pair ? q->id_pair: -1, n);
     idnsCallback(q, message->answer, n, q->error);
     rfc1035MessageDestroy(message);
 
     idnsTcpCleanup(q);
-    if (!q_pair) {
-	cbdataFree(q);
-/*
-	cbdataFree(q_pair);
-*/
-    }
+    cbdataFree(q);
 }
 
 static void
@@ -876,7 +840,7 @@
 {
     int *N = &incoming_sockets_accepted;
     ssize_t len;
-    struct sockaddr_storage from;
+    struct sockaddr_in from;
     socklen_t from_len;
     int max = INCOMING_DNS_MAX;
     static char rbuf[SQUID_UDP_SO_RCVBUF];
@@ -902,13 +866,13 @@
 		    fd, xstrerror());
 	    break;
 	}
-	fd_bytes(fd, len, FD_READ);
+	fd_bytes(DnsSocket, len, FD_READ);
 	assert(N);
 	(*N)++;
 	debug(78, 3) ("idnsRead: FD %d: received %d bytes from %s.\n",
 	    fd,
 	    (int) len,
-	    sockaddr_ntoa(&from));
+	    inet_ntoa(from.sin_addr));
 	ns = idnsFromKnownNameserver(&from);
 	if (ns >= 0) {
 	    nameservers[ns].nreplies++;
@@ -916,7 +880,7 @@
 	    static time_t last_warning = 0;
 	    if (squid_curtime - last_warning > 60) {
 		debug(78, 1) ("WARNING: Reply from unknown nameserver [%s]\n",
-		    sockaddr_ntoa(&from));
+		    inet_ntoa(from.sin_addr));
 		last_warning = squid_curtime;
 	    }
 	    continue;
@@ -924,7 +888,7 @@
 	idnsGrokReply(rbuf, len);
     }
     if (lru_list.head)
-	commSetSelect(fd, COMM_SELECT_READ, idnsRead, NULL, 0);
+	commSetSelect(DnsSocket, COMM_SELECT_READ, idnsRead, NULL, 0);
 }
 
 static void
@@ -986,15 +950,15 @@
     CBDATA_INIT_TYPE(idns_query);
     if (DnsSocket < 0) {
 	int port;
-	struct sockaddr_storage addr;
-	memset(&addr, 0, sizeof(addr));
-	addr.ss_family = AF_INET;
-#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
-	addr.ss_len = sizeof(struct sockaddr_in);
-#endif
+	struct in_addr addr;
+	if (Config.Addrs.udp_outgoing.s_addr != no_addr.s_addr)
+	    addr = Config.Addrs.udp_outgoing;
+	else
+	    addr = Config.Addrs.udp_incoming;
 	DnsSocket = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    &addr,
+	    addr,
+	    0,
 	    COMM_NONBLOCKING,
 	    "DNS Socket");
 	if (DnsSocket < 0)
@@ -1004,32 +968,9 @@
 	 */
 	port = comm_local_port(DnsSocket);
 	debug(78, 1) ("DNS Socket created at %s, port %d, FD %d\n",
-	    sockaddr_ntoa(&addr),
+	    inet_ntoa(addr),
 	    port, DnsSocket);
     }
-    if (DnsSocket6 < 0) {
-	int port;
-	struct sockaddr_storage addr;
-	memset(&addr, 0, sizeof(addr));
-	addr.ss_family = AF_INET6;
-#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
-	addr.ss_len = sizeof(struct sockaddr_in6);
-#endif
-	DnsSocket6 = comm_open(SOCK_DGRAM,
-	    IPPROTO_UDP,
-	    &addr,
-	    COMM_NONBLOCKING,
-	    "DNS Socket v6");
-	if (DnsSocket < 0)
-	    fatal("Could not create a DNS socket");
-	/* Ouch... we can't call functions using debug from a debug
-	 * statement. Doing so messes up the internal _db_level
-	 */
-	port = comm_local_port(DnsSocket6);
-	debug(78, 1) ("DNS Socket v6 created at %s, port %d, FD %d\n",
-	    sockaddr_ntoa(&addr),
-	    port, DnsSocket6);
-    }
     assert(0 == nns);
     idnsParseNameservers();
 #ifndef _SQUID_MSWIN_
@@ -1064,12 +1005,10 @@
 void
 idnsShutdown(void)
 {
-    if (DnsSocket < 0 && DnsSocket6 < 0)
+    if (DnsSocket < 0)
 	return;
     comm_close(DnsSocket);
-    comm_close(DnsSocket6);
     DnsSocket = -1;
-    DnsSocket6 = -1;
     idnsFreeNameservers();
     idnsFreeSearchpath();
 }
@@ -1098,57 +1037,6 @@
     hash_join(idns_lookup_hash, &q->hash);
 }
 
-static void
-idnsAAAALookup(const char *name, IDNSCB * callback, void *data, unsigned short id_pair, unsigned short id)
-{
-    unsigned int i;
-    int nd = 0;
-    idns_query *q;
-    q = cbdataAlloc(idns_query);
-    q->tcp_socket = -1;
-    q->id = id;
-    q->id_pair = id_pair;
-
-    for (i = 0; i < strlen(name); i++) {
-	if (name[i] == '.') {
-	    nd++;
-	}
-    }
-
-    if (Config.onoff.res_defnames && npc > 0 && name[strlen(name) - 1] != '.') {
-	q->do_searchpath = 1;
-    } else {
-	q->do_searchpath = 0;
-    }
-    strcpy(q->orig, name);
-    strcpy(q->name, q->orig);
-    if (q->do_searchpath && nd < ndots) {
-	q->domain = 0;
-	strcat(q->name, ".");
-	strcat(q->name, searchpath[q->domain].domain);
-	debug(78, 3) ("idnsALookup: searchpath used for %s\n",
-	    q->name);
-    }
-    q->sz = rfc1035BuildAAAAQuery(q->name, q->buf, sizeof(q->buf), q->id,
-	&q->query);
-
-    if (q->sz < 0) {
-	/* problem with query data -- query not sent */
-	callback(data, NULL, 0, "Internal error");
-	cbdataFree(q);
-	return;
-    }
-    debug(78, 3) ("idnsAAAALookup: buf is %d bytes for %s, id = %#hx\n",
-	(int) q->sz, q->name, q->id);
-    q->callback = callback;
-    q->callback_data = data;
-    cbdataLock(q->callback_data);
-    q->start_t = current_time;
-    idnsCacheQuery(q);
-    idnsSendQuery(q);
-}
-
-
 void
 idnsALookup(const char *name, IDNSCB * callback, void *data)
 {
@@ -1160,7 +1048,6 @@
     q = cbdataAlloc(idns_query);
     q->tcp_socket = -1;
     q->id = idnsQueryID();
-    q->id_pair = idnsQueryID();
 
     for (i = 0; i < strlen(name); i++) {
 	if (name[i] == '.') {
@@ -1199,14 +1086,13 @@
     q->start_t = current_time;
     idnsCacheQuery(q);
     idnsSendQuery(q);
-    idnsAAAALookup(name, callback, data, q->id, q->id_pair);
 }
 
 void
-idnsPTRLookup(const struct sockaddr *addr, IDNSCB * callback, void *data)
+idnsPTRLookup(const struct in_addr addr, IDNSCB * callback, void *data)
 {
     idns_query *q;
-    const char *ip = sockaddr_ntoa(addr);
+    const char *ip = inet_ntoa(addr);
     q = cbdataAlloc(idns_query);
     q->tcp_socket = -1;
     q->id = idnsQueryID();
